;#### ### ## #
;#
;#  EIRCD v3.0.-1 by poiuy_qwert
;#
;#### ### ## #
;
;
;
;
;
;
;
;
;
;
;
;  Please consult the help file before using and especially editing/making plugins for this addon.
;
;
;
;
;
;
;
;
;
;
;
;
;

on *:LOAD:eircd3.setup.wizard

on *:START:eircd3.load.plugins

alias eircd3 {
  if ($sock(eircd3)) {
    if ($window(@EIRCD)) {
      window -a @EIRCD
      eircdv3 action * Server could not start: server is already running.
    }
    else echo $color(info) * Server could not start: server is already running.
  }
  else {
    eircd3.load.plugins
    hfree -w eircd3*
    var %m hmake eircd3.,%h hadd eircd3
    $left(%m,-1)
    %m $+ mode
    %m $+ completed
    %m $+ nicks
    %m $+ channels
    %m $+ ircops
    %m $+ ips
    %m $+ realhosts
    %m $+ commands
    %m $+ modes
    %h started $ctime
    %h users 0
    %h invisible 0
    %h ircops 0
    %h channels 0
    %h socket 0
    eircd3.settings
    if (!$eircdv3(server,port).set) eircdv3 action * Server could not start: no port supplied in settings.
    else {
      if ($window(@EIRCD)) {
        window -a @EIRCD
        clear @EIRCD
        clear -l @EIRCD
      }
      else window -k0eSl $+ $eircdv3(display,listwidth).set @EIRCD @EIRCD
      eircd3.window.update
      socklisten eircd3 $eircdv3(server,port).set
      eircdv3 action * Server started ( $+ $+($iif($ip,$v1,127.0.0.1),:,$eircdv3(server,port).set) $+ ) $iif($eircdv3(server,pass).set,with password $qt($v1),with no password) $+ .
      .signal -n eircd3.started
    }
  }
}

alias eircd3.off {
  close -@ @eircd*
  .timereircd3* off
  sockclose eircd3*
  hfree -w eircd3*
  .signal -n eircd3.off
}

alias eircd3.settings {
  if ($hget(eircd3.settings)) hfree eircd3.settings
  if ($hget(eircd3.help)) hfree eircd3.help
  if ($hget(eircd3.supported)) hfree eircd3.supported
  if ($hget(eircd3.glines)) hfree -w eircd3.gline*
  if ($hget(eircd3.motd)) hfree eircd3.motd
  if ($hget(eircd3.opermotd)) hfree eircd3.opermotd
  hmake eircd3.settings
  hmake eircd3.help
  hmake eircd3.supported
  hmake eircd3.glines
  hmake eircd3.motd
  hmake eircd3.opermotd
  var %a 1
  while ($ini($scriptdirsettings.ini,%a)) {
    var %b 1,%s $v1
    while ($ini($scriptdirsettings.ini,%s,%b)) {
      if (;* !iswm $v1) hadd eircd3.settings $+(%s,.,$v2) $readini($scriptdirsettings.ini,n,%s,$v2)
      inc %b
    }
    inc %a
  }
  hload -i eircd3.help $qt($scriptdirhelp.ini) help
  var %a 1
  while ($ini($scriptdirglines.ini,%a)) {
    var %b 1,%s $v1,%t 0,%h = eircd3.gline. $+ %s
    hmake %h
    while ($ini($scriptdirsettings.ini,%s,%b)) {
      var %i $v1
      if ($istok(who when expires reason,%i,32)) {
        if (%i == expires) && ($ctime >= expires) break
        hadd %h %i $readini($scriptdirsettings.ini,n,%s,%i)
        inc %t
      }
      inc %b
    }
    if (%t < 4) {
      remini $qt($scriptdirglines.ini) %s
      hfree %h
    }
    else hadd eircd3.glines %s 1
    inc %a
  }
  if (!$regex($eircdv3(server,pass).set,^[a-z0-9]{32}$)) hadd eircd3.settings server.pass
  var %a 1,%n 32 44 13 10 9 58 7
  while ($mid($eircdv3(chantypes).set,%a,1)) var %n = %n $asc($v1),%a = %a + 1
  hadd eircd3.settings settings.chanallow $eircdv3($eircdv3(chanallow).set,%n).re
  var %a 1
  while ($mid($eircdv3(prefixes).set,%a,1)) var %n = %n $asc($v1),%a = %a + 1
  hadd eircd3.settings settings.nickallow $eircdv3($eircdv3(nickallow).set,33 64 %n).re
  var %a 1,%h hadd eircd3.supported
  while ($hfind(eircd3.settings,glines.*,%a,w)) {
    hadd eircd3.settings $v1 $eircdv3($hget(eircd3.settings,$v1)).length
    inc %a
  }
  .signal -n eircd3.setup
  %h PREFIX ( $+ $eircdv3(modes).set $+ ) $+ $eircdv3(prefixes).set
  %h CHANTYPES $eircdv3(chantypes).set
  %h CHANMODES $eircdv3(chanmodes).set
  %h MAXCHANNELS $eircdv3(max,chans).set
  %h NICKLEN $eircdv3(max,nicklen).set
  %h NETWORK $eircdv3(server,name).set
  %h TOPICLEN $eircdv3(max,topiclen).set
  %h KICKLEN $eircdv3(max,kicklen).set
  %h AWAYLEN $eircdv3(max,awaylen).set
  %h CHANNELLEN $eircdv3(max,chanlen).set
  %h MODE $eircdv3(max,modes).set
  %h MAXTARGETS $eircdv3(max,targets).set
  var %a 1,%f1 $qt($scriptdirmotd.txt),%f2 $qt($scriptdiropermotd.txt),%m = $lines(%f1),%o = $lines(%f2)
  while (%a <= %m) || (%a <= %o) {
    if (%a <= %m) hadd eircd3.motd %a $read(%f1,%a)
    if (%a <= %o) hadd eircd3.opermotd %a $read(%f2,%a)
    inc %a
  }
  .signal -n eircd3.isupport
  eircdv3 action * Settings loaded.
}

alias eircd3.readset return $iif($hget(eircd3.settings),$hget(eircd3.settings,$iif(!$2,settings. $+ $1,$+($1,.,$2))),$readini($scriptdirsettings.ini,$iif(!$2,settings,$1),$iif(!$2,$1,$2)))
alias eircdv3 {
  if ($isid) {
    if ($prop == set) return $eircd3.readset($1,$2)
    elseif ($prop == re) {
      var %re /[^,%d $2
      tokenize 32 $1
      while ($1) {
        if ($regex(eircd,$1,^(\d+)-(\d+)$)) var %a $regml(eircd,1),%b $regml(eircd,2)
        else var %a $1,%b $1
        while (%a <= %b) {
          if (%a isnum 1-255) && (!$istok(%d,%a,32)) var %re = $+(%re,$iif($chr(%a) !isalnum,\),$v1)
          inc %a
        }
        tokenize 32 $2-
      }
      return %re $+ ]/g
    }
    elseif ($prop == length) return $int($calc($replacecs($1,y,*31556926+,M,*2629743.83+,w,*604800+,d,*86400+,h,*3600+,m,*60+,s,)))
    elseif ($prop == host) return $+($hget($1,username),@,$hget($1,host))
    elseif ($prop == addr) return $+($hget($1,nick),!,$hget($1,username),@,$hget($1,host))
    elseif ($prop == realaddr) return $+($hget($1,nick),!,$hget($1,username),@,$hget($1,realhost))
    elseif ($prop == gline) {
      var %a 1
      while ($hget(eircd3.glines,%a).item) {
        if ($v1 iswm $1) || ($1 iswm $v1) return eircd3.gline. $+ $hget(eircd3.glines,%a).item
        inc %a
      }
    }
    elseif ($prop == randstr) {
      var %a 0,%p,%c
      while (%a < $1) {
        %c = $chr($r(48,122))
        if (%c !isalnum) continue
        var %p = %p $+ %c,%a = %a + 1
      }
      return %p
    }
    elseif ($prop == banned) {
      var %a 1,%h eircd3.chan.bans. $+ $2,%ua $+($hget($1,nick),!,$hget($1,username),@,$hget($1,host)),%uaa $+($hget($1,nick),!,$hget($1,username),@,$hget($1,ip))
      while ($hget(%h,%a).item) {
        if ($v1 iswm %ua) || ($v1 iswm %uaa) return $true
        inc %a
      }
      return $false
    }
    elseif ($prop == chan) return $hget(eircd3.chan. $+ $1,chan)
  }
  else {
    if ($istok(action receive send,$1,32)) && ($window(@EIRCD)) {
      if ($1 == send) {
        if (eircd3.user.* iswm $2) {
          if (!$sock($2)) {
            eircd3.cmd.QUIT $2 :Read error: EOF from client
            return
          }
          .sockwrite -n $2-
        }
        else .signal -n $2-
      }
      if ($eircd3.readset(display,outgoing)) || ($1 != send) {
        var %e echo $eircd3.readset(display,$1) $iif($eircd3.readset(display,timestamp) != off,$iif($v1 == on,-t @EIRCD,@EIRCD $asctime($v1)),@EIRCD),%m $iif($1 != action,( $+ $2 $+ ): $3-,$2-),%c $ [ $+ [ $iif($1 == send,5,4) ] ]
        %e %m
        if ($window(@ $+ $2)) $replace(%e,@EIRCD,@ $+ $2) %m
        if ($left(%c,1) isin $eircd3.readset(settings,chantypes)) && ($window(@eircd3.chan. $+ %c)) $replace(%e,@EIRCD,@eircd3.chan. $+ %c) %m
      }
    }
  }
}

on *:SOCKLISTEN:eircd3:{
  eircdv3 action * A user is trying to connect...
  hinc eircd3 socket 1
  var %s eircd3.user. [ $+ [ $hget(eircd3,socket) ] ]
  hadd -m %s connected $ctime
  hadd %s check 1
  hadd %s user $hget(eircd3,users)
  .sockaccept %s
  if ($eircdv3(max,registerlen).set) $+(.timer,%s,.reg.timeout) 1 $v1 eircd3.timeout %s Registration
}
alias eircd3.timeout {
  eircdv3 action * $1 disconnected for a $2 Timeout.
  eircd3.cmd.QUIT $1 : $+ $2 Timeout.
}

on *:SOCKREAD:eircd3.user.*:{
  var %eircd,%s $sockname
  if ($sockerr) {
    eircdv3 action * %s disconnected for a Connection Error.
    eircd3.cmd.QUIT %s :Connection Error.
  }
  else {
    if (!$timer(%s $+ .ping)) && ($eircdv3(checkping).set) $+(.timer,%s,.ping) 0 $v1 $+(.timer,%s,.ping.timeout) 1 $eircdv3(max,pingtimeout).set eircd3.timeout $sockname Ping $(|,0) eircdv3 send %s PING : $+ $eircdv3(server,server).set
    sockread %eircd
    if (%eircd) eircd3.received %s %eircd
  }
}
alias eircd3.received {
  if ($hget($1,check)) {
    hdel $1 check
    eircd3.check.glines
    var %m : $+ $eircdv3(server,server).set NOTICE *,%c $eircdv3(max,clones).set,%i $sock($1).ip,%ip = eircd3.ip. $+ %i
    eircdv3 action * $1 is connecting on IP %i $+ ...
    if ($eircdv3(%i).gline) {
      var %g G-Lined by $hget($v1,who) on $asctime($hget($v1,when)) $+ , expires in $duration($calc($hget($v1,expires) - $ctime)) on $asctime($hget($v1,expires)) $+ .,%r = Reason: $hget($v1,reason)
      eircdv3 action * User %g
      eircdv3 action * %r
      eircdv3 send $1 %m : $+ %g
      eircdv3 send $1 %m : $+ %r
      eircd3.cmd.QUIT $1 : $+ %g
      halt
    }
    elseif ($hget(%ip,0).item >= %c) {
      var %a 1,%n $v1,%1 IP G-Lined.,%2 Last connection closed.,%e = :You have connected to $iif(%n > %c,more than) the maximum clones allowed: $eircdv3(max,clones).set $+ . $iif(%n > %c,$iif($eircdv3(clonegline).set,Result: %1,Result: %2))
      if (%n > %c) {
        if ($eircdv3(clonegline).set) eircdv3 action * User has too many connections: %1
        else {
          eircdv3 action * User has too many connections: %2
          eircd3.cmd.QUIT $1
        }
      }
      while ($hget(%ip,%a).item) {
        eircdv3 send $v1 %m %e
        inc %a
      }
      if (%n > %c) {
        if ($eircdv3(clonegline).set) eircd3.gline %i $eircdv3(server,server).set $ctime $calc($ctime +$eircdv3(glines,clone).set) Too many connections.
        halt
      }
    }
    hadd -m eircd3.ip. $+ %i $1 *
    hadd $1 ip %i
    if ($hget(eircd3.ips,%i)) && ($v1 != 1) {
      hadd -m eircd3.realhost. $+ %i $1 %i
      hadd $1 realhost %i
    }
    else {
      if (!$hget(eircd3.ips,%i)) hadd eircd3.ips %i 1
      hadd -m eircd3.realhost. $+ %i $1 %i
      hadd eircd3.realhosts %i 1
      hadd $1 realhost %i
      if ($eircdv3(realhosts).set) .dns %i
    }
  }
  eircdv3 receive $1-
  :eircd3.unknown
  var %c $hget(eircd3.commands,$2),%d $+(eircd3.cmd.,$2)
  if ($iif($isalias(%c),%c,$iif($isalias(%d),%d))) $v1 $1 $3-
  elseif ($2 != UNKNOWN) {
    tokenize 32 $1 UNKNOWN $2-
    goto eircd3.unknown
  }
}

on *:DNS:{
  var %i $dns(0).ip,%r $raddress
  if ($dns(0)) && ($hget(eircd3.realhosts,%i)) && (%i != %r) {
    hmake eircd3.realhost. $+ %r
    var %a 1
    while ($hget(eircd3.realhost. $+ %i,%a).item) {
      hadd eircd3.realhost. $+ %r $v1 %i
      hadd $v1 realhost %r
      inc %a
    }
    hfree eircd3.realhost. $+ %i
    hadd eircd3.realhosts %r $hget(eircd3.realhosts,%i)
    hdel eircd3.realhosts %i
    hadd eircd3.ips %i %r
  }
}

on *:SOCKCLOSE:eircd3.user.*:if ($hget($sockname)) eircd3.cmd.QUIT $sockname Connection terminated.

alias eircd3.cmd.PASS {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set
  if ($hget($1,registered)) %s 461 $hget($1,nick) :Already registered.
  elseif (!$2) %s 462 * PASS :Not enough parameters.
  else hadd $1 pass $md5($2)
}

alias eircd3.cmd.LUSERS {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  %s 251 %n :There are $calc($hget(eircd3,users)- $hget(eircd3,invisible)) users and $hget(eircd3,invisible) invisible out of the max $eircdv3(max,users).set on the server.
  %s 252 %n $hget(eircd3,ircops) :operator $+ $iif($hget(eircd3,ircops) != 1,s) online.
  %s 254 %n $hget(eircd3,channels) :channel $+ $iif($hget(eircd3,channels) != 1,s) formed.
}

alias eircd3.register {
  if ($isid) {
    if ($hget($1,user) > $eircdv3(max,users).set) || (($hget($1,user)) && ($eircdv3(server,pass).set) && ($v1 != $hget($1,pass))) {
      if ($hget($1,user) > $eircdv3(max,users).set) eircdv3 action * Connection refused: server is full.
      else {
        eircdv3 action * Connection refused: password incorrect.
        eircdv3 send $1 : $+ $eircdv3(server,server).set 464 * :Connection refused: password incorrect.
      }
      hdec eircd3 socket 1
      hfree $1
      return $false
    }
    if ($hget($1,user) != $null) {
      eircdv3 action * Connection accepted.
      aline -l @EIRCD $1
      hinc eircd3 users 1
      hdel $1 user
      eircd3.window.update
    }
    return $true
  }
  else {
    if ($hget($1,pass)) hdel $1 pass
    $+(.timer,$1,.reg.timeout) off
    var %a $eircdv3(server,name).set,%b $eircdv3(server,server).set,%s = eircdv3 send $1 : $+ %b,%n $hget($1,nick)
    hadd $1 registered $ctime
    hadd $1 modes $eircdv3(server,defaultusermodes).set
    %s 001 %n :Welcome to the %a IRC network, $hget($1,nick)
    %s 002 %n :Your host is %b $+ , running EIRCD v3.0.-1
    %s 003 %n :This server was created $replace($asctime($hget(eircd3,started),ddd mmm d yyyy - HH:nn:ss),-,at)
    %s 004 %n %b EIRCDv3.0.-1 $eircdv3(usermodes).set $remove($eircdv3(chanmodes).set,$chr(44))
    eircd3.isupport $1
    eircd3.cmd.LUSERS $1
    eircd3.cmd.MOTD $1
  }
}

alias eircd3.cmd.VERSION {
  var %b $eircdv3(server,server).set
  eircdv3 send $1 : $+ %b 351 $hget($1,nick) EIRCDv3.0.-1 %b
  eircd3.isupport $1
}
alias eircd3.isupport {
  var %a 1,%t,%s eircdv3 send $1 : $+ $eircdv3(server,server).set
  while ($hget(eircd3.supported,%a).item) {
    var %c $+($v1,=,$hget(eircd3.supported,$v1))
    if $calc(%a % ($eircdv3(max,isupport).set - 1)) == 1) || ($len(%t %c) > $eircdv3(max,lines).set) {
      %s 005 %t :are supported by this server.
      set %t %c
    }
    else set %t %t %c
    inc %a
  }
  if (%t) %s 005 %t :are supported by this server.
}

alias eircd3.cmd.NICK {
  if ($eircd3.register($1)) {
    tokenize 32 $1 $iif(:* iswm $2,$right($2,-1),$2)
    var %n $iif($hget($1,nick),$v1,*),%s eircdv3 send $1 : $+ $eircdv3(server,server).set
    if (!$2) %s 431 %n :Not enough parameters.
    elseif ($regex($2,$eircdv3(nickallow).set)) %s 432 %n $2 :Erroneous Nickname ( $+ $v1 errors).
    elseif ($eircdv3(blacklist,$2)) && (!$hget(eircd3.ircops,$1)) %s 432 %n $2 :Nickname is blacklisted.
    elseif ($hget(eircd3.nicks,$2)) %s 433 %n $2 :Nickname is already in use.
    elseif ($hget($1,nick)) && (!$hget($1,registered)) %s 451 %n :Not registered.
    else {
      if (!$hget(eircd3.ircops,$1)) {
        var %a 1
        while ($hfind($1,eircd3.chan.*,w,%a)) {
          var %c $v1
          if (m iswmcs $hget(%c,modes)) || ($eircdv3($1,%c).banned) {
            %s 437 %n :Cannot change nickname while banned on channel or channel is moderated ( $+ %c $+ )
            return
          }
          inc %a
        }
      }
      if ($hget($1,nick)) hdel eircd3.nicks $v1
      if ($hget($1,registered)) {
        var %a 1,%t : $+ $eircdv3($1).addr NICK $2
        while ($hfind($1,eircd3.chan.*,%a,w)) {
          var %b 1,%c $v1
          while ($hfind(%c,eircd3.user*.*,%b,w)) {
            var %h $v1
            if (!$hget(eircd3.completed,%h)) {
              eircdv3 send %h %t
              hadd eircd3.completed %h 1
            }
            inc %b
          }
          inc %a
        }
        if (!$hget(eircd3.completed,$1)) eircdv3 send $1 %t
        hdel -w eircd3.completed *
        eircd3.window.update $1
      }
      hadd eircd3.nicks $2 $1
      hadd -m eircd3.ip. $+ $hget($1,ip) $1 $2
      hadd -m $1 nick $2
      if (!$hget($1,registered)) && ($hget($1,username)) eircd3.register $1
    }
  }
}

alias eircd3.cmd.USER {
  if ($eircd3.register($1)) {
    var %s = eircdv3 send $1 : $+ %b,%n $hget($1,nick),%h hadd $1
    if ($hget($1,registered)) %s 451 %n :Already registered.
    elseif (!$5) %s 461 %n USER :Not enough parameters.
    else {
      %h username $noqt($2)
      %h hostname $noqt($3)
      %h host $hget($1,ip)
      %h name $iif(:* iswm $5,$right($5-,-1),$5-)
      if (%n) eircd3.register $1
    }
  }
}

alias eircd3.cmd.PING {
  var %s $eircdv3(server,server).set
  eircdv3 send $1 : $+ %s $iif($2,PONG %s $iif(:* iswm $2-,$2-,: $+ $2-),409 $hget($1,nick) :No origin specified)
}

alias eircd3.cmd.PONG $+(.timer,$1,.ping.timeout) off

alias eircd3.cmd.MOTD {
  var %a $eircdv3(server,server).set,%s = eircdv3 send $1 : $+ %a,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  else {
    %s 375 %n :- %a Message of the Day -
    if (!$hget(eircd3.motd)) %s 372 %n :- MOTD missing.
    else {
      var %a 1
      while (%a <= $hget(eircd3.motd,0).item) {
        %s 372 %n :- $hget(eircd3.motd,%a)
        inc %a
      }
    }
    %s 376 %n :End of /MOTD command.
  }
}

alias eircd3.cmd.OPERMOTD {
  var %a $eircdv3(server,server).set,%s = eircdv3 send $1 : $+ %a,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You are not an IRC Operator.
  else {
    %s 375 %n :- %a Oper Message of the Day -
    if (!$hget(eircd3.opermotd)) %s 372 %n :- Oper MOTD missing.
    else {
      var %a 1
      while (%a <= $hget(eircd3.opermotd,0).item) {
        %s 372 %n :- $hget(eircd3.opermotd,%a)
        inc %a
      }
    }
    %s 376 %n :End of /OPERMOTD command.
  }
}

alias eircd3.cmd.USERHOST {
  var %n $hget($1,nick),%s eircdv3 send $1 : $+ $eircdv3(server,server).set,%t $hget(eircd3.nicks,$2)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) %s 461 %n USERHOST :Not enough parameters.
  elseif (!%t) %s 401 %n $2 :No such nick.
  else %s 302 %n $+(:,$2,$iif($hget(eircd3.ircops,%t),*),=,$iif($hget(%t,away),-,+),$eircdv3(%t).host)
}

alias eircd3.mode if (!$hfind(eircd3.mode,$1-,0).data) hadd -m eircd3.mode send. $+ $hget(eircd3.mode,0).item $1-
alias eircd3.cmd.MODE {
  var %s eircdv3 send $1 : $+ $eircdv3($1).addr,%e eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick),%hadd hadd eircd3.mode
  if (!$hget($1,username)) %e 451 %n :Not registered.
  elseif ($left($2,1) isincs $eircdv3(chantypes).set) {
    var %h eircd3.chan. $+ $2
    tokenize 32 $1 $hget(%h,chan) $3-
    if (!$3) || ((+* !iswm $3) && (-* !iswm $3)) {
      var %a 1,%p
      while ($mid($hget(%h,modes),%a,1)) var %p = %p $+ $ [ $+ [ $+(eircd3.cmode.,$v1,$chr(40),$1,$chr(44),$2,$chr(41),.param) ] ],%a = %a + 1
      %e 324 %n $2 + $+ $hget(%h,modes) %p
      %e 329 %n $2 $hget(%h,created)
    }
    elseif (!$hfind(%h,$1,0)) %e 442 %n $2 :You're not on that channel.
    else {
      var %a 2,%cm $eircdv3(chanmodes).set,%co $chr(44),%um $eircdv3(modes).set
      %hadd +- $left($3,1)
      %hadd +-added 0
      %hadd params $4-
      %hadd currentmodes $hget(%h,modes)
      %hadd validmodes
      %hadd validparams
      %hadd modes 0
      while ($hget(eircd3.mode,modes) < $eircdv3(max,modes).set) && ($mid($3,%a,1)) {
        var %c $v1,%u = $iif($hget(eircd3.modes,cmode. $+ %c),$v1,eircd3.cmode. $+ %c),%x $calc($hget(eircd3.mode,0).item +1)
        if ($istok(+ -,%c,32)) {
          if (%c != $hget(eircd3.mode,+-)) {
            %hadd +-added 0
            %hadd +- %c
          }
        }
        else {
          var %p $gettok($hget(eircd3.mode,params),1,32)
          if (%c !isincs %um) && (%c !isincs $remove(%cm,$chr(44))) eircd3.mode %e 472 %n %c :unknown channel mode.
          elseif ((%c isincs %um) || (%c isincs $remove($left(%cm,$pos(%cm,%co,3)),%co))) && (($hget(eircd3.mode,+-) == +) || (%c isincs %um $+ $left(%cm,$pos(%cm,%co,1)))) {
            if (!$isalias(%u)) eircd3.mode %e 472 %n %c :Unknown channel mode.
            elseif (%c !isincs $gettok(%cm,1,44)) && (!$hget(eircd3.mode,params)) eircd3.mode %e 461 %n MODE %c :not enough parameters.
            elseif ($($+($,%u,$chr(40),$1,$chr(44),$2,$chr(44),$hget(eircd3.mode,+-),$chr(44),%p,$chr(41)),2)) $iif(error * iswm $v1,eircd3.mode %e $gettok($v2,2-,32),!noop)
            else {
              if (%c !isincs %um) %hadd currentmodes $iif($hget(eircd3.mode,+-) == +,$hget(eircd3.mode,currentmodes) $+ %c,$removecs($hget(eircd3.mode,currentmodes),%c))
              %hadd validmodes $+($hget(eircd3.mode,validmodes),$iif(!$hget(eircd3.mode,+-added),$hget(eircd3.mode,+-)),%c)
              %hadd validparams $hget(eircd3.mode,validparams) %p
              hinc eircd3.mode modes 1
              %hadd +-added 1
              %hadd params $gettok($hget(eircd3.mode,params),2-,32)
              %u $1-2 $hget(eircd3.mode,+-) %p
            }
          }
          elseif (($hget(eircd3.mode,+-) == +) && (%c !isincs $hget(eircd3.mode,currentmodes))) || (($hget(eircd3.mode,+-) == -) && (%c isincs $hget(eircd3.mode,currentmodes)))  {
            if ($isalias(%u)) && ($($+($,%u,$chr(40),$1,$chr(44),$2,$chr(44),$hget(eircd3.mode,+-),$chr(41)),2)) $iif(error * iswm $v1,eircd3.mode %e $gettok($v2,2-,32),!noop)
            else {
              %hadd currentmodes $iif($hget(eircd3.mode,+-) == +,$hget(eircd3.mode,currentmodes) $+ %c,$removecs($hget(eircd3.mode,currentmodes),%c))
              %hadd validmodes $+($hget(eircd3.mode,validmodes),$iif(!$hget(eircd3.mode,+-added),$hget(eircd3.mode,+-)),%c)
              hinc eircd3.mode modes 1
              %hadd +-added 1
              if ($isalias(%u)) %u $1-2 $hget(eircd3.mode,+-)
            }
          }
        }
        inc %a
      }
      var %a 1
      while ($hget(eircd3.mode,%a).item) {
        if (send.* iswm $v1) $hget(eircd3.mode,%a).data
        inc %a
      }
      if ($hget(eircd3.mode,validmodes)) {
        var %a 1
        while ($hfind(%h,eircd3.user*.*,%a,w)) {
          eircdv3 send $v1 : $+ $eircdv3($1).addr MODE $2 $hget(eircd3.mode,validmodes) $hget(eircd3.mode,validparams)
          inc %a
        }
        hadd %h modes $hget(eircd3.mode,currentmodes)
      }
      hdel -w eircd3.mode *
      eircd3.window.update %h
    }
  }
  else {
    if (!$hget(eircd3.nicks,$2)) %e 401 %n $2 :Unknown user.
    elseif ($2 != $hget($1,nick)) %e 502 %n :Cant change mode for other users.
    elseif (!$3) || ((+* !iswm $3) && (-* !iswm $3)) %e 221 %n + $+ $hget($1,modes)
    else {
      var %a 2
      %hadd +- $left($3,1)
      %hadd +-added 0
      %hadd currentmodes $hget($1,modes)
      %hadd validmodes
      %hadd modes 0
      while ($hget(eircd3.mode,modes) < $eircdv3(max,modes).set) && ($mid($3,%a,1)) {
        var %c $v1,%u = $iif($hget(eircd3.modes,umode. $+ %c),$v1,eircd3.umode. $+ %c),%x $calc($hget(eircd3.mode,0).item +1)
        if ($istok(+ -,%c,32)) {
          if (%c != $hget(eircd3.mode,+-)) {
            %hadd +-added 0
            %hadd +- %c
          }
        }
        else {
          if (%c !isincs $eircdv3(usermodes).set) eircd3.mode %e 472 %n %c :unknown user mode.
          elseif ($isalias(%u)) && ($($+($,%u,$chr(40),$1,$chr(44),$hget(eircd3.mode,+-),$chr(41)),2)) $iif(error * iswm $v1,eircd3.mode %e $gettok($v2,2-,32),!noop)
          elseif (($hget(eircd3.mode,+-) == +) && (%c !isincs $hget(eircd3.mode,currentmodes))) || (($hget(eircd3.mode,+-) == -) && (%c isincs $hget(eircd3.mode,currentmodes))) {
            %hadd validmodes $+($hget(eircd3.mode,validmodes),$iif(!$hget(eircd3.mode,+-added),$hget(eircd3.mode,+-)),%c)
            %hadd currentmodes $iif($hget(eircd3.mode,+-) == +,$hget(eircd3.mode,currentmodes) $+ %c,$removecs($hget(eircd3.mode,currentmodes),%c))
            hinc eircd3.mode modes 1
            %hadd +-added 1
            if ($isalias(%u)) %u $1 $hget(eircd3.mode,+-)
          }
        }
        inc %a
      }
      var %a 1
      while ($hget(eircd3.mode,%a).item) {
        if (send.* iswm $v1) $hget(eircd3.mode,%a).data
        inc %a
      }
      if ($hget(eircd3.mode,validmodes)) {
        eircdv3 send $1 : $+ $eircdv3($1).addr MODE %n $hget(eircd3.mode,validmodes)
        hadd $1 modes $hget(eircd3.mode,currentmodes)
      }
      hdel -w eircd3.mode *
      eircd3.window.update $1
    }
  }
}

alias eircd3.cumode {
  var %h eircd3.chan. $+ $2,%n $hget($1,nick),%t $hget(eircd3.nicks,$4),%m = $hget(%h,%t)
  if ($isid) {
    if ($left($hget(%h,$1),1) !isincs $eircdv3(chanops).set) && (!$hget(eircd3.ircops,$1)) && (($3 == +) || ($1 != %t)) return error 482 %n $2 :You must be a channel operator.
    elseif (!$4) || (($3 == +) && ($5 isincs $hget(%h,%t))) || (($3 == -) && ($5 !isincs $hget(%h,%t))) return $true
    elseif (!%t) return error 401 %n $4 :No such nick.
    elseif (!$hfind(%h,%t,0)) return error 441 %n $4 $2 :User not in channel.
  }
  elseif ($3 == +) {
    var %a 1,%p $eircdv3(modes).set
    while ($pos(%p,$mid(%m,%a,1),1) < $pos(%p,$5,1)) inc %a
    dec %a
    hadd %h %t $+($left(%m,%a),$5,$right(%m,$calc($len(%m)-%a)))
  }
  else hadd %h %t $removecs(%m,$5)
}
alias eircd3.cmode.o {
  if ($isid) && (!$prop) return $eircd3.cumode($1,$2,$3,$4,o)
  else eircd3.cumode $1-4 o
}
alias eircd3.cmode.v {
  if ($isid) && (!$prop) return $eircd3.cumode($1,$2,$3,$4,v)
  else eircd3.cumode $1-4 v
}

alias eircd3.cmode.k {
  var %h eircd3.chan. $+ $2
  if ($isid) {
    if ($prop == param) return $hget(%h,key)
    elseif ($left($hget(%h,$1),1) !isincs $eircdv3(chanops).set) && (!$hget(eircd3.ircops,$1)) return error 482 %n $2 :You must be a channel operator.
    elseif ($3 == +) && ($hget(%h,key)) return error 467 $hget($1,nick) $2 :Channel key allready set.
    elseif ($3 == -) && (!$hget(%h,key)) return $true
  }
  elseif ($3 == +) hadd %h key $4
  else hdel %h key
}

alias eircd3.cmode.l {
  var %h eircd3.chan. $+ $2
  if ($isid) {
    if ($prop == param) return $hget(%h,limit)
    elseif ($left($hget(%h,$1),1) !isincs $eircdv3(chanops).set) && (!$hget(eircd3.ircops,$1)) return error 482 %n $2 :You must be a channel operator.
    elseif (($3 == +) && ($4 !isnum 1-)) || (($3 == -) && (!$hget(%h,limit))) return $true
  }
  elseif ($3 == +) hadd %h limit $3
  else hdel %h limit
}

alias eircd3.cmode.sp {
  var %h eircd3.chan. $+ $2,%hadd hadd eircd3.mode
  if ($isid) {
    if ($left($hget(%h,$1),1) !isincs $eircdv3(chanops).set) && (!$hget(eircd3.ircops,$1)) return error 482 %n $2 :You must be a channel operator.
    elseif (($3 == +) && ($4 isincs $hget(%h,modes))) || (($3 == -) && ($4 !isincs $hget(%h,modes))) return $true
  }
  elseif (!$isid) && ($3 == +) && ($5 isincs $hget(eircd3.mode,currentmodes)) {
    %hadd currentmodes $removecs($hget(eircd3.mode,currentmodes),$5)
    %hadd validmodes $+($hget(eircd3.mode,validmodes),-,$5)
  }
}
alias eircd3.cmode.s {
  if ($isid) && (!$prop) return $eircd3.cmode.sp($1,$2,$3,s,p)
  else eircd3.cmode.sp $1-3 s p
}
alias eircd3.cmode.p {
  if ($isid) && (!$prop) return $eircd3.cmode.sp($1,$2,$3,p,s)
  else eircd3.cmode.sp $1-3 p s
}

alias eircd3.cmode.operator if ($left($hget(eircd3.chan. $+ $2,$1),1) !isincs $eircdv3(chanops).set) && (!$hget(eircd3.ircops,$1)) return error 482 %n $2 :You must be a channel operator.
alias eircd3.cmode.C if ($isid) && (!$prop) return $eircd3.cmode.operator($1,$2)
alias eircd3.cmode.c if ($isid) && (!$prop) return $eircd3.cmode.operator($1,$2)
alias eircd3.cmode.N if ($isid) && (!$prop) return $eircd3.cmode.operator($1,$2)
alias eircd3.cmode.i {
  if ($isid) && (!$prop) {
    if ($eircd3.cmode.operator($1,$2)) return $v1
    else eircd3.window.update
  }
}
alias eircd3.cmode.x if ($isid) && (!$prop) return $eircd3.cmode.operator($1,$2)
alias eircd3.cmode.n if ($isid) && (!$prop) return $eircd3.cmode.operator($1,$2)
alias eircd3.cmode.t if ($isid) && (!$prop) return $eircd3.cmode.operator($1,$2)

alias eircd3.banmask {
  if (!$1) return
  var %i $pos($1,!),%h $pos($1,@)
  if (!%i) && (!%h) return $1 $+ !*@*
  elseif (%i) && (!%h) return $1 $+ @*
  elseif (%h) && ((!%i) || (%i > %h)) return *! $+ $1
}
alias eircd3.banlist {
  var %s sockwrite -n $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick),%h eircd3.chan.bans. $+ $2
  if ($hget(%h,$3).item) {
    %s 367 %n $2 $v1 $hget(%h,$v1)
    $+(.timer,%h,.,$1) -m 1 1 eircd3.banlist $1-2 $calc(1+$3)
  }
  else %s 368 %n $2 :End of Channel Ban List
}
alias eircd3.cmode.b {
  tokenize 32 $1-3 $eircd3.banmask($4)
  var %h eircd3.chan.bans. $+ $2,%n $hget($1,nick),%p $hget(eircd3.mode,validparams)
  if ($isid) && (!$prop) {
    if ($3 == -) && (!$hget(%h,$4)) return $true
    elseif ($3 == +) && ((!$4) || ($hget(%h,$4))) {
      if (!$4) && (!$timer($+(%h,.,$1))) eircd3.banlist $1-2 1
      return $true
    }
  }
  else {
    if ($3 == +) hadd -m %h $4 %n $ctime
    else hdel %h $4
    hadd eircd3.mode validparams $iif($calc($numtok(%p,32) -1) > 0,$gettok(%p,1- $+ $v1,32)) $4
    hadd eircd3.mode currentmodes $left($hget(eircd3.mode,currentmodes),-1)
  }
}

alias eircd3.umode.i {
  if (!$isid) {
    if ($2 == +) hinc eircd3 invisible 1
    else hdec eircd3 invisible 1
  }
}

alias eircd3.umode.x {
  if ($isid) && (!$prop) && ($2 == -) return $true
  elseif (!$isid) {
    var %a $eircdv3($1).addr
    hadd $1 host $eircdv3(hostmask).set $+ $gettok($1,3,46)
    eircd3.vhost.register $1 %a
    eircdv3 send $1 %s 396 $hget($1,nick) $hget($1,host) :is now your $iif($2 == +,hidden) host.
  }
}

alias eircd3.umode.o {
  if ($isid) && (($2 == +) || (($2 == -) && (o !isincs $hget($1,modes)))) return $true
  elseif (!$isid) {
    hdel eircd3.ircops $1
    hdec eircd3 ircops 1
    eircdv3 send $1 : $+ $eircdv3(server,server).set NOTICE $hget($1,nick) :You are no longer an Operator.
    hadd eircd3.mode validmodes $+($hget(eircd3.mode,validmodes),$iif(w isincs $hget(eircd3.mode,currentmodes),w),$iif(c isincs $hget(eircd3.mode,currentmodes),c))
    hadd eircd3.mode currentmodes $removecs($hget(eircd3.mode,currentmodes),w,c)
  }
}

alias eircd3.umode.w if ($isid) && (!$hget(eircd3.ircops,$1)) return $true
alias eircd3.umode.c if ($isid) && (!$hget(eircd3.ircops,$1)) return $true

alias eircd3.cmd.WHOIS {
  var %n $hget($1,nick),%s eircdv3 send $1 : $+ $eircdv3(server,server).set
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) %s 431 %n :No nickname given.
  else {
    var %a 1
    while (%a <= $eircdv3(max,targets).set) && ($gettok($2,%a,44)) {
      var %o $v1,%t = $hget(eircd3.nicks,%o)
      if (!%t) %s 401 %n %o :No such nick.
      else {
        if (w isincs $hget(%t,modes)) eircdv3 send %t : $+ $eircdv3(server,server).set NOTICE %n :The user %n has whoised you.
        %s 311 %n %o $hget(%t,username) $hget(%t,host) * : $+ $hget(%t,name)
        if (c !isincs $hget(%t,modes)) {
          var %b 1,%c
          while ($hfind(%t,eircd3.chan.*,%b,w)) {
            var %h $v1,%o = $gettok(%h,3-,46)
            if (s !isincs $hget(%h,modes)) || ($hfind(%h,$1,0)) {
              var %f = $mid($eircdv3(prefixes).set,$pos($eircdv3(modes).set,$left($hget(%h,%t),1),1),1) $+ %o
              if ($len(%c %f) > $eircdv3(max,lines).set) {
                %s 319 %n $2 : $+ %c
                set %c %f
              }
              else set %c %c %f
            }
            inc %b
          }
          if (%c) %s 319 %n $2 : $+ %c
        }
        %s 312 %n $2 $eircdv3(server,server).set : $+ $eircdv3(server,info).set
        if (B isincs $hget(%t,modes)) eircdv3 send %t : $+ $eircdv3(server,server).set 335 %n $2 :is a bot.
        if (%t == $1) || ($hget(eircd3.ircops,$1)) %s 338 %n $2 $+($hget(%t,username),@,$hget(%t,realhost)) $hget(%t,ip) :Actual user@host, Actual IP.
        if ($hget(eircd3.ircops,%t)) %s 338 $hget($1,nick) $2 :is an ircop.
      }
      inc %a
    }
    %s 318 %n $2 :End of /WHOIS list.
  }
}

alias eircd3.cmd.INVITE {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick),%t $hget(eircd3.nicks,$2),%h eircd3.chan. $+ $3
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) {
    var %a 1
    while ($hfind($1,invite.*,%a,w)) {
      %s 346 %n : $+ $gettok($v1,3-,46)
      inc %a
    }
    %s 347 %n :End of Invite List.
  }
  else {
    if (!$3) %s 461 %n INVITE :Not enough parameters.
    else {
      tokenize 32 $1 $hget(%h,chan) $2-
      elseif (!$hget(%h)) %s 403 %n $3 :No such channel.
      elseif (!$hget(%h,$1)) %s 441 %n $3 :You're not on that channel.
      elseif ($left($hget(%h,$1),1) !isincs $eircdv3(chanops).set) %s 482 %n $3 :You must be a channel operator.
      elseif (!%t) %s 401 %n $2 :No such nick.
      elseif ($hget(%h,%t)) %s 443 %n $2-3 :is already on channel
      else {
        eircdv3 send %t : $+ $eircdv3($1).host INVITE $2 : $+ $3
        %s 341 %n $2-3
        var %a 1
        while ($hfind(%h,eircd3.user*.*,%a,w)) {
          eircdv3 send $v1 : $+ $eircdv3(server,server).set 345 %n $3 $2 %n : $+ $2 has been invited by %n
          inc %a
        }
        hadd %t invite. $+ %h 1
      }
    }
  }
}

alias eircd3.cmd.JOIN {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) %s 461 %n JOIN :Not enough parameters.
  else {
    var %a 1,%p 1
    while (%a <= $eircdv3(max,targets).set) && ($gettok($2,%a,44)) {
      var %o $v1,%h = eircd3.chan. $+ %o,%j,%m = $hget(%h,modes)
      if ($left(%o,1) !isincs $eircdv3(chantypes).set) %s 403 %n %o :No such channel.
      elseif ($calc($len(%o)-1) > $eircdv3(max,chanlen).set) %s 403 %n $hget(%h,chan) :Channel name too long.
      elseif ($regex($right(%o,-1),$eircdv3(chanallow).set)) %s 403 %n $hget(%h,chan) :Erroneous channel name.
      elseif ($hfind($1,eircd3.chan.*,0,w) > $eircdv3(max,chans).set) %s 405 %n $hget(%h,chan) :You are in the maximum amount of channels allowed.
      elseif (!$hfind(%h,$1,0)) {
        if ($hget(%h)) {
          %o = $hget(%h,chan)
          if (!$hget(eircd3.icops,$1)) {
            %j = 1
            if ($eircdv3($1,%o).banned) && (!$hget(eircd3.icops,$1)) %s 474 %n %o :Cannot join channel (+b)
            elseif (O isincs %m) && (!$hget(eircd3.icops,$1)) %s 482 %n %o :You must be an IRC Operator (+O).
            elseif (x isincs %m) && (x !isincs $hget($1,modes)) %s 477 %n %o :Channel is registered users only (+x).
            elseif (k isincs %m) && ($gettok($3-,%p,32) != $hget(%h,key)) %s 475 %n %o :Invalid channel key (+k).
            elseif (l isincs %m) && ($hfind(%h,eircd3.user*.*,0,w) == $hget(%h,limit)) %s 471 %n %o :Channel is full (+l).
            elseif (i isincs %m) && (!$hget($1,invite. $+ %h)) %s 473 %n %o :Cannot join channel (+i).
            else %j = 0
          }
          if (!%j) {
            if ($window(@ $+ $1)) aline -l @ $+ $1 %h
            if ($window(@ $+ %h)) {
              aline -l @ $+ %h $1
              eircd3.window.update %h
            }
            hadd %h $1
            if (i isincs %m) hdel $1 invite. $+ %h
          }
        }
        else {
          aline -l @EIRCD %h
          hinc eircd3 channels 1
          hadd eircd3.channels %o 1
          hadd -m %h created $ctime
          hadd %h chan %o
          hadd %h modes $eircdv3(server,defaultchanmodes).set
          hadd %h $1 $left($eircdv3(modes).set,1)
          eircd3.window.update
        }
        if ($hfind(%h,$1,0)) {
          hadd $1 %h 1
          var %b 1
          while ($hfind(%h,eircd3.user*.*,%b,w)) {
            eircdv3 send $v1 : $+ $eircdv3($1).addr JOIN %o
            inc %b
          }
          if ($hget(%h,topic)) eircd3.cmd.TOPIC $1-2
          eircd3.cmd.NAMES $1 %o
        }
      }
      inc %a
    }
  }
}

alias eircd3.cmd.TOPIC {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick),%h eircd3.chan. $+ $2
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) %s 461 %n TOPIC :Not enough parameters.
  else {
    tokenize 32 $1 $hget(%h,chan) $3-
    if (!$3) {
      if (!$hget(%h)) %s 403 %n $2 :No such channel.
      elseif (!$hget(%h,topic)) %s 331 %n $2 :No topic set.
      else {
        %s 332 %n $2 : $+ $replace($hget(%h,topic),$!chan,$2,$!nick,%n,$!time,$time,$!date,$asctime(ddd mmm dd))
        %s 333 %n $2 $hget(%h,topicwho) $hget(%h,topicwhen)
      }
    }
    elseif (!$hfind(%h,$1,0)) %s 442 %n $2 :You're not on that channel.
    elseif (!$hget(eircd3.ircops,$1)) && (t isincs $hget(%h,modes)) && ($left($hget(%h,$1),1) !isincs $eircdv3(chanops).set) %s 482 %n $2 :You must be a channel operator.
    else {
      if ($3 == :) hdel -w %h topic*
      else {
        hadd %h topic $left($iif(:* !iswm $3,$3-,$right($3-,-1)),$eircdv3(max,topiclen).set)
        hadd %h topicwho %n
        hadd %h topicwhen $ctime
      }
      eircd3.window.update %h
      var %a 1
      while ($hfind(%h,eircd3.user*.*,%a,w)) {
        eircdv3 send $v1 : $+ $eircdv3($1).addr TOPIC $2 : $+ $replace($hget(%h,topic),$!chan,$2,$!nick,%n,$!time,$time,$!date,$asctime(ddd mmm dd))
        inc %a
      }
    }
  }
}

alias eircd3.cmd.NAMES {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) %s 461 %n NAMES :Not enough parameters.
  else {
    var %a 1
    while (%a <= $eircdv3(max,targets).set) && ($gettok($2,%a,44)) {
      var %b 1,%o $v1,%h = eircd3.chan. $+ %o,%c
      while ($hfind(%h,eircd3.user*.*,%b,w)) {
        var %q $v1,%f = $mid($eircdv3(prefixes).set,$pos($eircdv3(modes).set,$left($hget(%h,%q),1),1),1) $+ $hget(%q,nick)
        if (i !isincs $hget(%q,modes)) || ($hfind(%h,$1,0)) {
          if ($len(%c %f) > $eircdv3(max,lines).set) {
            %s 353 %n $iif(s isincs $hget(%h,modes),@,$iif(p isincs $v2,*,=)) $hget(%h,chan) : $+ %c
            set %c %f
          }
          else set %c %c %f
        }
        inc %b
      }
      if (%c) %s 353 %n = $hget(%h,chan) : $+ %c
      %s 366 %n $hget(%h,chan) :End of /NAMES list.
      inc %a
    }
  }
}

alias -l eircd3.msg {
  var %s eircdv3 send $2 : $+ $eircdv3(server,server).set,%n $hget($2,nick)
  if (!$hget($2,registered)) %s 451 %n :Not registered.
  elseif (!$4) %s 461 %n $1 :Not enough parameters.
  else {
    var %a 1
    while (%a <= $eircdv3(max,targets).set) && ($gettok($3,%a,44)) {
      var %o $v1,%t = $hget(eircd3.nicks,%o)
      if ($left(%o,1) isincs $eircdv3(chantypes).set) {
        var %h = eircd3.chan. $+ %o,%m = $hget(%h,modes)
        if (!$hget(%h)) %s 403 %n %o :No such channel.
        elseif (!$hget(eircd3.ircops,$1)) && $&
          (((n isincs %m) && (!$hfind(%h,$2,0))) ||  $&
          ((m isincs %m) && ($left($hget(%h,$2),1) !isincs $eircdv3(modes).set)) || $&
          ((c isincs %m) && ($strip($4-) != $4-) && ((C !isincs %m) || (!$hfind(%h,$2,0)))) || $&
          ((N isincs %m) && ($chr(1) isincs $left($4,2))) || $&
          ($eircdv3($1,%o).banned)) %s 404 %n $hget(%h,chan) :Cannot send to channel.
        else {
          var %b 1
          while ($hfind(%h,eircd3.user*.*,%b,w)) {
            if ($v1 != $2) eircdv3 send $v1 : $+ $eircdv3($2).addr $1 $hget(%h,chan) $iif(:* !iswm $4-,:) $+ $iif(C isincs $hget(%h,modes) && $hfind(%h,$2,0),$4-,$iif(S isincs $hget(%h,modes),$strip($4-),$4-))
            inc %b
          }
        }
      }
      elseif (!%t) %s 401 %n %o :No such nick.
      else {
        if ($hget(%t,away)) {
          %s 301 %n $hget(%t,nick) : $+ $v1
          if (a isincs $hget(%t,modes)) {
            inc %a
            continue
          }
        }
        eircdv3 send %t : $+ $eircdv3($2).addr $1 %n $iif(:* !iswm $4-,:) $+ $iif(S isincs $hget(%t,modes),$strip($4-),$4-)
      }
      inc %a
    }
  }
}
alias eircd3.cmd.PRIVMSG eircd3.msg PRIVMSG $1-
alias eircd3.cmd.NOTICE eircd3.msg NOTICE $1-

alias eircd3.cmd.KICK {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$3) %s 461 %n KICK :Not enough parameters.
  else {
    var %a 1
    while (%a <= $eircdv3(max,targets).set) &&  ($gettok($2,%a,44)) {
      var %o $v1,%h = eircd3.chan. $+ %o,%w = @ $+ %h
      if ($left(%o,1) !isincs $eircdv3(chantypes).set) %s 403 %n %o :No such channel.
      elseif (!$hfind(%h,$1,0)) %s 442 %n $hget(%h,chan) :You're not on that channel.
      elseif ($left($hget(%h,$1),1) !isincs $eircdv3(chanops).set) %s 482 %n $hget(%h,chan) :You must be a channel operator.
      else {
        var %b 1,%o = $hget(%h,chan)
        while (%a <= $eircdv3(max,targets).set) && ($gettok($3,%b,44)) {
          var %u $v1,%t = $hget(eircd3.nicks,%u)
          if (!$hfind(%h,%t,0)) %s 441 %n %u %o :No such nick.
          else {
            var %c 1
            while ($hfind(%h,eircd3.user*.*,%c,w)) {
              eircdv3 send $v1 : $+ $eircdv3($1).addr KICK %o %u $iif($4,$iif(:* !iswm $4,: $+ $left($4-,$eircdv3(max,topiclen).set),$left($4-,$calc(1+ $eircdv3(max,topiclen).set))))
              inc %c
            }
            if ($hfind(%h,eircd3.user*.*,0,w) == 1) {
              if ($window(%w)) window -c %w
              dline -l @EIRCD $fline(@EIRCD,%h,1,1)
              hfree %h
              hdel eircd3.channels %o
              hdec eircd3 channels 1
              eircd3.window.update
            }
            else {
              if ($window(%w)) dline -l %w $fline(%w,%t,1,1)
              hdel %h %t
              hdel %t %h
            }
          }
          inc %b
        }
      }
      inc %a
    }
  }
}

alias eircd3.cmd.PART {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) %s 461 %n PART :Not enough parameters.
  else {
    var %a 1,%m $iif(!$3,: $+ %n,$iif(:* !iswm $3,:) $+ $3-)
    while (%a <= $eircdv3(max,targets).set) && ($gettok($2,%a,44)) {
      var %o $v1,%h = eircd3.chan. $+ %o,%w = @ $+ %h
      if (!$hget(%h)) %s 403 %n %o :No such channel.
      elseif (!$hfind(%h,$1,0)) %s 442 %n $hget(%h,chan) :You're not on that channel.
      else {
        %o = $hget(%h,chan)
        if ($hfind(%h,eircd3.user*.*,0,w) > 1) {
          if ($window(%w)) {
            dline -l %w $fline(%w,$1,1,1)
            eircd3.window.update %h
          }
          var %b 1
          while ($hfind(%h,eircd3.user*.*,%b,w)) {
            eircdv3 send $v1 : $+ $eircdv3($1).addr PART %o %m
            inc %b
          }
          hdel %h $1
        }
        else {
          if ($window(%w)) window -c %w
          dline -l @EIRCD $fline(@EIRCD,%h,1,1)
          hdec eircd3 channels 1
          hfree %h
          hdel eircd3.channels %o
          eircd3.window.update
          eircdv3 send $1 : $+ $eircdv3($1).addr PART %o %m
        }
        hdel $1 %h
      }
      inc %a
    }
  }
}

alias eircd3.cmd.AWAY {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) && ($hget($1,away)) {
    hdel $1 away
    %s 305 %n :You are no longer marked as being away.
  }
  elseif ($2) {
    hadd $1 away $iif(:* iswm $2,$right($2-,-1),$2-)
    %s 306 %n :You have been marked as being away.
  }
}

alias -l eircd3.who {
  var %s eircdv3 send $2 : $+ $eircdv3(server,server).set,%n $hget($2,nick),%o $gettok($3,1,44),%h = eircd3.chan. $+ %o
  if ($1 > $eircdv3(max,list).set) %s 416 %n %o :Too many matches.
  elseif ($left(%o,1) isincs $eircdv3(chantypes).set) && ($hfind(%h,eircd3.user*.*,$1,w)) {
    if ($hget(eircd3.ircops,$v1)) || (!$4) {
      var %t $hfind(%h,eircd3.user*.*,$1,w)
      %s 352 %n %o $hget(%t,username) $hget(%t,host) $eircdv3(server,server).set $hget(%t,nick) * :1 $hget(%t,name)
    }
    .timereircd3.who. $+ $2 -m 1 1 eircd3.who $calc(1+$1) $2-
  }
  elseif ($hget(eircd3.nicks,$1).data) {
    if (%o iswm $hget($v1,nick)) && (($hget(eircd3.ircops,$hget(eircd3.nicks,$1).data)) || (!$4)) {
      var %a 1,%t $hget(eircd3.nicks,$1).data,%c *
      while ($hfind(%t,eircd3.chan.*,%a,w)) {
        var %c $v1
        if ($hget(%c,$2)) break
        inc %a
      }
      if (%c) || (i isincs $hget($2,modes)) %s 352 %n $gettok(%c,3-,46) $hget(%t,username) $hget(%t,host) $eircdv3(server,server).set $hget(%t,nick) * :1 $hget(%t,name)
    }
    .timereircd3.who. $+ $2 -m 1 1 eircd3.who $calc(1+$1) $2-
  }
  else {
    %s 315 %n %o :End of /WHO list.
    if ($gettok($3,2-,44)) .timereircd3.who. $+ $2 -m 1 1 eircd3.who 1 $2 $gettok($3-,2-,44)
  }
}
alias eircd3.cmd.WHO {
  if (!$hget($1,registered)) eircdv3 send $1 : $+ $eircdv3(server,server).set 451 $hget($1,nick) :Not registered.
  else eircd3.who 1 $1 $iif(!$2,*,$gettok($2,1- $+ $eircdv3(max,targets).set,44) $iif($3 == o,o))
}

alias -l eircd3.list {
  var %s eircdv3 send $2 : $+ $eircdv3(server,server).set,%n $hget($2,nick),%o $iif(!$3,$hget(eircd3.channels,$1).item,$gettok($3,1,44)),%h = eircd3.chan. $+ %o
  if ($1 > $eircdv3(max,list).set) %s 416 %n %o :Too many matches.
  elseif (%o) {
    %s 322 %n %o $hfind(%h,eircd3.user*.*,0,w) : $+ $hget(%h,topic)
    if ($gettok($3,2-,44)) .timereircd3.list. $+ $2 -m 1 1 eircd3.list $calc(1+$1) $2 $v1
    elseif (!$3) && ($1 < $hget(eircd3,channels)) .timereircd3.list. $+ $2 -m 1 1 eircd3.list $calc(1+$1) $2
    else %s 323 %n :End of /LIST
  }
}
alias eircd3.cmd.LIST {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  else {
    %s 321 %n Channel :Users Name
    eircd3.list 1 $1-2
  }
}

alias eircd3.cmd.ADMIN {
  var %b $eircdv3(server,server).set,%s = eircdv3 send $1 : $+ %b,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  else {
    %s 256 %n :Administrative info about %b
    %s 257 %n : $+ $eircdv3(server,name).set ( $+ $eircdv3(server,location).set $+ )
    %s 258 %n :Hub - $eircdv3(server,info).set
    %s 259 %n : $+ $eircdv3(admin,name).set $+(<,$eircdv3(admin,email).set,>)
  }
}

alias eircd3.cmd.TIME {
  var %b $eircdv3(server,server).set,%s = eircdv3 send $1 : $+ %b,%z $asctime(zz)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  else %s 391 $hget($1,nick) %b : $+ $asctime(dddd mmmm d yyyy -- hh:nn) $+($left(%z,-2),:,$right(%z,2))
}

alias eircd3.cmd.MODULE {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  else {
    var %a 1
    while ($hget(eircd3.plugins,%a).item) {
      var %p $v1
      if ($group($(#,0) $+ %p) == on) %s NOTICE %n : $+ $replace($gettok(%p,3-,46),_,$chr(32)) v $+ $hget(%p,version) by $hget(%p,author) (Website: $hget(%p,website) Contact: $hget(%p,contact) $+ )
      inc %a
    }
  }
}

alias eircd3.cmd.OPER {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$3) %s 461 %n OPER :Not enough parameters.
  else {
    if (!$eircdv3(ircops,$2).set) %s 491 %n :No O-lines for your host.
    elseif ($eircdv3(ircops,$2).set != $md5($3)) %s 464 %n :Password incorrect.
    elseif ($hget(eircd3.ircops,$1)) %s NOTICE %n :You are already an IRC Operator.
    else {
      %s MODE %n +o
      %s 381 %n :You are now an IRC Operator.
      hadd $1 modes $hget($1,modes) $+ o
      hadd eircd3.ircops $1-2
      hinc eircd3 ircops 1
      eircd3.cmd.OPERMOTD $1
    }
  }
}

alias eircd3.cmd.AOPER {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s 481 %n :You must be an IRC Operator to use that command.
  elseif (!$2) %s 461 %n AOPER :Not enough parameters.
  elseif ($eircdv3(ircops,$2).set) %s NOTICE %n :That account is allready registered.
  else {
    var %p $eircdv3($eircdv3(operpass).set).randstr
    hadd eircd3.settings ircops. $+ $2 $md5(%p)
    writeini -n $qt($scriptdirsettings.ini) ircops $2 $md5(%p)
    %s NOTICE %n :Account $2 has been created with the password %p $+ .
  }
}

alias eircd3.cmd.POPER {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$3) %s 461 %n POPER :Not enough parameters.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You must login to change your password.
  elseif ($md5($2) != $eircdv3(ircops,$hget(eircd3.ircops,$1)).set) %s NOTICE %n :The old password is incorrect.
  else {
    var %a $hget(eircd3.ircops,$1)
    hadd eircd3.settings ircops. $+ %a $md5($3)
    writeini -n $qt($scriptdirsettings.ini) ircops %a $md5($3)
    %s NOTICE %n :Your password has been changed to $3 $+ .
  }
}

alias eircd3.cmd.REHASH {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You are not an IRC Operator.
  else { 
    eircd3.settings
    %s NOTICE %n :Rehash successful!
  }
}

alias eircd3.cmd.GLOBAL {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You are not an IRC Operator.
  elseif (!$2) %s 461 %n GLOBAL :Not enough parameters.
  else {
    var %a 1,%r : $+ GLOBAL!GLOBAL@ $+ $eircdv3(server,server).set NOTICE GLOBAL :
    while ($hget(eircd3.nicks,%a).data) {
      var %t $v1
      if (!$2 == -o) || ($hget(eircd3.ircops,%t)) {
        eircdv3 send %t %r $+ [ $+ $iif($2 == -o,Operator Global,Global) from $hget($1,nick) $+ ]
        eircdv3 send %t %r $+ $iif($2 == -o,$3-,$2-)
      }
      inc %a
    }
  }
}

alias eircd3.vhost.register {
  hadd eircd3.completed $1 1
  var %a 1,%n : $+ $eircdv3($1).addr,%o : $+ $2,%s : $+ $eircdv3(server,server).set 
  while ($hfind($1,eircd3.chan.*,%a,w)) {
    var %b 1,%c $v1
    while ($hfind(%c,eircd3.user*.*,%b,w)) {
      var %h $v1
      if (!$hget(eircd3.completed,%h)) {
        eircdv3 send %h %o QUIT :Hostmask Enabled.
        eircdv3 send %h %n JOIN $hget(%c,chan)
        if ($hget(%c,$1)) eircdv3 send %h %s MODE $hget(%c,chan) + $+ $v1 $str($hget($1,nick) $+ $chr(32),$len($v1))
        hadd eircd3.completed %h 1
      }
      inc %b
    }
    inc %a
  }
  hdel -w eircd3.completed *
}
alias eircd3.cmd.VHOST {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You are not an IRC Operator.
  elseif (!$3) %s 461 %n VHOST :Not enough parameters.
  else {
    var %a 1
    while (%a <= $eircdv3(max,targets).set) && ($gettok($2,%a,44)) {
      var %o $v1,%t = $hget(eircd3.nicks,%o),%h = $eircdv3(%t).addr
      if (!%t) %s 401 %n %o :No such nick.
      elseif ($gettok(%h,2,64) == $3) %s NOTICE %n :User %o already has the host $3 $+ .
      else {
        hadd %t host $3
        eircd3.vhost.register %t %h
        eircdv3 send %t : $+ $eircdv3(server,server).set NOTICE %o :Your Virtual Host has been set to $3 by %n $+ .
        %s NOTICE %n :Virtual Host for %o set to $3 $+ .
      }
      inc %a
    }
  }
}

alias eircd3.cmd.KILL {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You are not an IRC Operator.
  elseif (!$3) %s 461 %n KILL :Not enough parameters.
  else {
    var %a 1
    while (%a <= $eircdv3(max,targets).set) && ($gettok($2,%a,44)) {
      var %o $v1,%t = $hget(eircd3.nicks,%o)
      if (!%t) %s 401 %n %o :No such nick.
      else {
        eircdv3 send $1 : $+ $eircdv3(server,server).set NOTICE %n : $+ %o has been successfully killed for: $iif(:* iswm $3,$right($3-,-1),$3-)
        eircd3.cmd.QUIT %t Killed by %n $+ : $iif(:* iswm $3,$right($3-,-1),$3-)
      }
      inc %a
    }
  }
}

alias eircd3.cmd.CLOSE {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You are not an IRC Operator.
  elseif (!$3) %s 461 %n KILL :Not enough parameters.
  else {
    var %a 1
    while ($gettok(
  }
}

alias eircd3.check.glines {
  var %a 1
  while ($hget(eircd3.glines,%a).item) {
    var %i $v1,%h = eircd3.gline. $+ %i
    if ($hget(%h,expires) > 0) && ($ctime >= $hget(%h,expires)) {
      remini $qt($scriptdirglines.ini) %i
      hfree %h
      hdel eircd3.glines %i
    }
    else inc %a
  }
}
alias -l eircd3.gline.add {
  hadd -m eircd3.gline. $+ $1-
  writeini -n $qt($scriptdirglines.ini) $1-
}
alias eircd3.gline {
  hadd eircd3.glines $1 1
  var %a eircd3.gline.add $1
  %a who $2
  %a when $3
  %a expires $4
  %a rawset $5
  %a reason $6-
  var %a 1
  while ($hget(eircd3.ips,%a).item) {
    var %ip $v1
    if ($1 iswm %ip) {
      var %i 1
      while ($hget(eircd3.ip. $+ %ip,%i).item) {
        var %t $v1
        if (!$hget(eircd3.ircops,%t)) {
          eircdv3 send %t : $+ $eircdv3(server,server).set NOTICE $hget(%t,nick) :G-Lined by $2 $+ : $6- (Expires: $asctime($4) $+ )
          eircd3.cmd.QUIT %t G-Lined by $2 $+ : $6-
        }
        else {
          eircdv3 send %t : $+ $eircdv3(server,server).set NOTICE $hget(%t,nick) : $+ $2 set a G-Line that matches your IP. Type /rgline -t $1 to remove it.
          inc %i
        }
      }
    }
    if ($1 !iswm %ip) || ($hget(eircd3.ips,%ip)) inc %a
  }
}
alias eircd3.cmd.GLINE {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You are not an IRC Operator.
  elseif (!$4) %s 461 %n GLINE :Not enough parameters.
  else {
    if ($2 == -f) {
      var %f 1
      tokenize 32 $1 $3-
    }
    if ($eircdv3($3).length !isnum 1-) %s NOTICE %n :Invalid expiration length.
    else {
      eircd3.check.glines
      var %i 1,%r (255|(25[0-5\*])|2[0-4\*][\d\*]|[01*]?[\d\*]?[\d\*]),%ip = $iif($regex($2,$+(^,$chr(40),?:,%r,\.,$chr(41),{3},%r,$($,0))),$2)
      if (!%ip) {
        var %a 1
        while ($hget(eircd3.nicks,%a).data) {
          var %t $v1
          if (($2 iswm $hget(%t,nick)) || ($2 iswm $eircdv3(%t).addr) || ($2 iswm $eircdv3(%t).realaddr)) {
            %ip = $hget(%t,ip)
            break
          }
          inc %a
        }
      }
      if (!%ip) %s NOTICE %n :No matches for $2 $+ .
      else {
        if ($eircdv3(%ip).gline) %s NOTICE %n :There is already a G-Line matching %ip $+ : $gettok($v1,3-,46) $+ . $iif(%f,Forcing new G-Line.,G-Line not set; use /gline -f $2- to force the G-Line.))
        if (%f) || (!$eircdv3(%ip).gline) {
          eircd3.gline %ip $hget(eircd3.ircops,$1) $ctime $iif($eircdv3($3).length > 0,$calc($ctime +$v1),0) $2 $4-
          %s NOTICE %n :G-Line set on %ip $+ !
        }
      }
    }
  }
}

alias eircd3.time.range {
  if ($1 == *) return $true
  if ($regex($1,^([0-9yMwdhms]+)(-([0-9yMwdhms]+)?)?$)) {
    var %a $regml(0)
    if (%a > 1) && ($eircdv3($regml(1)).length <= $2) && ((%a == 2) || ($eircdv3($regml(3)).length >= $2)) return $true
    if (%a == 1) && ($eircdv3($regml(1)).length == $2) return $true
  }
  return $false
}
alias eircd3.gline.lists {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$hget(eircd3.ircops,$1)) %s NOTICE %n :You are not an IRC Operator.
  elseif ($3 == -m0) %s NOTICE %n :0 is an invalid maximum match amount.
  else {
    if ($regex($3,^-(\d+)$)) {
      var %m $regml(1)
      tokenize 32 $1-2 $4-
    }
    if ($0 < 8) tokenize 32 $1- $str(* $+ $chr(32),$calc(8-$0))
    var %a 1,%f 0
    while ((!%m) || (%f < %m)) && ($hget(eircd3.glines,%a).item) {
      var %i $v1,%h = eircd3.gline. $+ %i
      if ($3 iswm $hget(%h,who)) && (($4 iswm %i) || ($4 iswm $hget(%h,rawset))) && ($eircd3.time.range($5,$calc($ctime - $hget(%h,when)))) && ($eircd3.time.range($6,$calc($hget(%h,expires) - $hget(%h,when)))) && ($eircd3.time.range($7,$calc($hget(%h,expires) - $ctime))) && ($8 iswm $hget(%h,reason)) {
        inc %f
        $2 $1 %h
      }
      inc %a
    }
    return %f
  }
}
alias eircd3.GLINES.list eircdv3 send $1 : $+ $eircdv3(server,server).set NOTICE $hget($1,nick) :IP $gettok($2,3-,46) (origional match: $hget($2,rawset) $+ ) G-Lined by $hget($2,who) on $asctime($hget($2,when)) $+ , expires in $duration($calc($hget($2,expires) - $ctime)) on $asctime($hget($2,expires)) $+ . Reason: $hget($2,reason)
alias eircd3.cmd.GLINES {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  %s NOTICE %n :Listing G-Lines matching search:
  if ($eircd3.gline.lists( [ $replace($1 eircd3.GLINES.list $2-,$chr(32),$chr(44)) ] ) isnum 1-) %s NOTICE %n :End of /GLINES list.
  elseif ($v1 isnum) %s NOTICE %n :No G-Lines where found matching that criteria.
}

alias eircd3.RGLINES.list {
  eircdv3 send $1 : $+ $eircdv3(server,server).set NOTICE $hget($1,nick) :Removing G-Line on IP $gettok($2,3-,46) (origional match: $hget($2,rawset) $+ ) G-Lined by $hget($2,who) on $asctime($hget($2,when)) $+ , expires in $duration($calc($hget($2,expires) - $ctime)) on $asctime($hget($2,expires)) $+ . Reason: $hget($2,reason)
  hdel eircd3.glines $2
  hfree $2
}
alias eircd3.cmd.RGLINES {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set,%n $hget($1,nick)
  %s NOTICE %n :Removing G-Lines matching search:
  if ($eircd3.gline.lists( [ $replace($1 eircd3.RGLINE.list $2-,$chr(32),$chr(44)) ] ) isnum 1-) %s NOTICE %n :End of /RGLINE list.
  elseif ($v1 isnum) %s NOTICE %n :No G-Lines where found matching that criteria.
}

alias eircd3.cmd.HELP {
  var %h : $+ $eircdv3(server,server).set,%s = eircdv3 send $1 %h,%n $hget($1,nick)
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  elseif (!$2) {
    var %a 1
    while ($hget(eircd3.help,%a).item) {
      %s NOTICE %n : $+ $upper($v1)
      inc %a
    }
  }
  else {
    if ($hget(eircd3.help,$2)) {
      var %a 1 $noop($regex($v1,/(?:(.+?)\\n)|(?:(.+?)$)/g)),%f 1
      while (%a <= $regml(0)) {
        var %o $regml(%a)
        if (%o) {
          if (%f) { 
            %s NOTICE %n :[Command $upper($2) help]
            %f = 0
          }
          %s NOTICE %n : $+ $replace(%o,\b,)
        }
        inc %a
      }
    }
    else %s NOTICE %n : $+ $2 is an invalid command. Type /help for a list of commands.
  }
}

alias eircd3.cmd.QUIT {
  $+(.timer,$1,*) off
  if ($fline(@EIRCD,$1,1,1)) dline -l @EIRCD $v1
  if ($window(@ $+ $1)) window -c @ $+ $1
  hadd -m eircd3.completed $1 1
  var %a 1,%i $sock($1).ip,%h $hget($1,realhost)
  while ($hfind($1,eircd3.chan.*,%a,w)) {
    var %h $v1,%o = $gettok(%h,3-,46),%w = @ $+ %h
    if ($hfind(%h,eircd3.user*.*,0,w) == 1) {
      hdec eircd3 channels 1
      hfree %h
      hdel eircd3.channels %o
      eircd3.window.update
      if ($window(%w)) window -c %w
      dline -l @EIRCD $fline(@EIRCD,%h,1,1)
    }
    else {
      if ($window(%w)) {
        dline -l %w $fline(%w,$1,1,1)
        eircd3.window.update %h
      }
      hdel %h $1
      var %b 1
      while ($hfind(%h,eircd3.user*.*,%b,w)) {
        var %o $v1
        if (!$hget(eircd3.completed,%o)) {
          eircdv3 send %o : $+ $eircdv3($1).addr QUIT $iif(:* !iswm $2,: $+ $left($2-,$eircdv3(max,quitlen).set),$left($2-,$calc(1+ $eircdv3(max,quitlen).set)))
          hadd eircd3.completed %o 1
        }
        inc %b
      }
    }
    inc %a
  }
  hdel -w eircd3.completed *
  hdec eircd3 users 1
  if ($hget(eircd3.ip. $+ %i,0).item > 1) hdel eircd3.ip. $+ %i $1
  elseif (%i) {
    if ($hget(eircd3.ip. $+ %i)) hfree $v1
    if ($hget(eircd3.ips,%i)) hdel eircd3.ips %i
  }
  if ($hget(eircd3.realhost. $+ %h,0).item > 1) hdel eircd3.realhost. $+ %h $1
  elseif (%h) {
    if ($hget(eircd3.realhost. $+ %r)) hfree $v1
    if ($hget(eircd3.realhosts,%r)) hdel eircd3.realhosts %r
  }
  if ($hget($1,registered)) {
    hdel eircd3.nicks $hget($1,nick)
    if (i isincs $hget($1,modes)) hdec eircd3 invisible 1
    if ($hget(eircd3.ircops,$1)) {
      hdel eircd3.ircops $1
      hdec eircd3 ircops 1
    }
    .timereircd3.*. $+ $1 off
  }
  if ($hget($1)) hfree $1
  if ($sock($1)) sockclose $1
}

alias eircd3.cmd.UNKNOWN {
  var %s eircdv3 send $1 : $+ $eircdv3(server,server).set
  if (!$hget($1,registered)) %s 451 %n :Not registered.
  else eircdv3 send $1 : $+ $eircdv3(server,server).set 421 $hget($1,nick) $2 :Unknown Command
}

on *:CLOSE:@:if ($target == @EIRCD) eircd3.off
on *:EXIT:eircd3.off
on *:UNLOAD:eircd3.off

alias eircd3.windows {
  var %a 1
  while ($sline($1,%a)) {
    var %h $v1,%w = @ $+ %h
    if (!$window(%w)) {
      window -k0eSl $+ $eircdv3(display,listwidth).set %w %w
      eircd3.window.update %h
      var %b 1
      while ($hfind(%h,$iif(eircd3.user*.* iswm %h,eircd3.chan.*,eircd3.user*.*),%b,w)) {
        aline -l %w $v1
        inc %b
      }
    }
    inc %a
  }
}
alias eircd3.window.update {
  if (!$1) titlebar @EIRCD v3.0.-1 Console $+([Users: $hget(eircd3,users),] [Invisible: $hget(eircd3,invisible),] [IRCOps: $hget(eircd3,ircops),] [Channels: $hget(eircd3,channels),])
  var %w @ $+ $1
  if ($window(%w)) {
    if (eircd3.user*.* iswm $1) titlebar %w $+([Address: $eircdv3($1).addr,] [IP: $hget($1,ip),] [Channels: $hfind($1,eircd3.chan.*,0,w),]) $iif($hget($1,modes),[Modes: $+(+,$v1,]))
    elseif (eircd3.chan.* iswm $1) {
      var %a 1,%p
      while ($mid($hget($1,modes),%a,1)) var %p = %p $+ $ [ $+ [ $+(eircd3.cmode.,$v1,$chr(40),$chr(44),$gettok($1,3-,46),$chr(41),.param) ] ],%a = %a + 1
      titlebar %w [Users: $hfind($1,eircd3.user*.*,0,w) $+ ] $iif($hget($1,modes),$+([Modes: +,$v1 %p,])) $iif($hget($1,topic),[Topic: $v1 $+ ])
    }
  }
}
menu @EIRCD {
  dclick:eircd3.windows $active
}
menu @eircd3.*.* {
  dclick:eircd3.windows $active
}

on *:INPUT:@eircd3.*.*:{
  var %w $active,%h = $right(%w,-1),%c = $iif(*.chan.* iswm %h,1,0),%s : $+ $eircdv3(server,server).set NOTICE,%e $count($left($1,2),/),%r $right($1,- $+ %e)
  if (!$hget(%h)) echo $color(info) * This $iif(%c,channel,user) no longer exists.
  else {
    if (!%e) || ($ctrlenter) {
      if (%c) {
        var %a 1
        while ($hfind(%h,eircd3.user*.*,%a,w)) {
          eircdv3 send $v1 %s $gettok(%h,3-,46) : $+ $1-
          inc %a
        }
      }
      else eircdv3 send %h %s $hget(%h,nick) : $+ $1-
    }
    else {
      if (%c) {
        if ($iif(eircd3.user*.* !iswm $2,You must supply a user to execute a command for.,$iif(!$hget($2),That user doesn't exists.,$iif(!$hfind(%h,$2),That user isn't on that channel.))) != $!) {
          echo $eircdv3(display,action).set * $v1
          return
        }
        %h = $2
        tokenize 32 . $3-
      }
      var %1 = $hget(eircd3.commands,%r),%2 = $+(eircd3.cmd.,%r)
      if ($iif($isalias(%1),%1,$iif($isalias(%2),%2))) $v1 %h $2-
    }
    haltdef
  }
}

menu * {
  -
  EIRCD
  .Turn EIRCD $iif($sock(eircd3),Off,On):eircd3 $+ $iif($sock(eircd3),.off)
  .Plugins:eircd3.plugin.manager
  .Settings
  ..Setup Wizard:eircd3.setup.wizard
  ..Settings:run $qt($scriptdirsettings.ini)
  ..MOTD:run $qt($scriptdirmotd.txt)
  ..OperMOTD:run $qt($scriptdiropermotd.txt)
  .Readme/Help:run $qt($scriptdirreadme.html)
  -
}

;#### ### ## #
;#
;#  EIRCD Plugin Manager
;#
;#### ### ## #

dialog eircd3.plugin.manager {
  title "EIRCD Plugin Manager"
  size -1 -1 478 274
  option pixels
  list 1, 4 5 150 235, size
  text "Author:", 7, 172 18 60 16, right
  text "", 2, 236 18 225 16
  text "Version:", 8, 172 39 60 16, right
  text "", 3, 236 39 225 16
  text "Website:", 9, 172 60 60 16, right
  text "", 4, 236 60 225 16
  text "Contact:", 10, 172 81 60 16, right
  text "", 5, 236 81 225 16
  text "Description:", 11, 172 102 60 16, right
  edit "", 6, 172 120 291 93, read multi vsbar
  box "Plugin Information", 12, 161 0 313 239
  check "Enabled", 13, 404 215 58 20, disable
  button "Ok", 14, 398 245 75 25, default cancel
  text "Plugin Manager for EIRCD v3.0.-1", 15, 5 249 163 16, disable
}

alias eircd3.plugin.manager dialog $iif($dialog(eircd3.plugin.manager),-v,-md) eircd3.plugin.manager eircd3.plugin.manager

alias eircd3.load.plugins {
  var %a 1
  while ($findfile($scriptdirplugins\,*.mrc,%a)) {
    var %b 1,%f $v1,%c 1,%o 0,%h
    while (%c) && (%b <= $lines(%f)) {
      var %l = $read(%f,n,%b)
      if (%b == 1) {
        if (!$regex(%l,^; (.+) v(.+) by (.+)$)) break
        var %p $replace($regml(1),$chr(32),_),%h = eircd3.plugin. $+ %p
        if ($hget(eircd3.plugins,%h)) break
        hadd -m %h file %f
        hadd %h version $regml(2)
        hadd %h author $regml(3)
      }
      elseif (%b == 2) {
        if (!$regex(%l,^; Website: (.+) Contact: (.+)$)) {
          hfree %h
          break
        }
        hadd %h website $regml(1)
        hadd %h contact $regml(2)
      }
      elseif (%b == 3) {
        if (!$regex(%l,^; Requires EIRCD: (v3\.\d\.\d) Commands: (\S+) Modes: ([a-zA-Z]+|\*)/([a-zA-Z]+|\*)$)) || $&
          (($regml(1) != v3.0.-1) && (!$input(The plugin being loaded $+ $chr(44) $replace(%p,_,$chr(32)) v $+ $hget(%h,version) by $hget(%h,author) $+ $chr(44) is for a different version of EIRCD ( $+ $v1 $+ ) and may not work properly. Continue loading?,y,Versions Possibly Incompatible))) {
          hfree %h
          break
        }
        hadd %h required.commands $regml(2)
        hadd %h required.cmodes $regml(3)
        hadd %h required.umodes $regml(4)
      }
      elseif (%o) {
        if (!$regex(%l,^# $+ %h (off|on)$)) hfree %h
        break
      }
      elseif (%b > 1) {
        if (; * iswm %l) hadd -m %h desc. $+ $calc($hfind(%h,desc.*,0,w)+1) $right(%l,-1)
        elseif (!$hget(%h,desc.1)) {
          hfree %h
          break
        }
        else %o = 1
      }
      inc %b
    }
    if ($hget(%h)) && (!$hget(eircd3.plugins,%h)) && (($regml(1) == off) || ($eircdv3(plugins,%p).set) || ($input(The plugin being loaded $+ $chr(44) $replace(%p,_,$chr(32)) v $+ $hget(%h,version) by $hget(%h,author) $+ $chr(44) is already turned on. Continue loading?,y,Security Risk))) {
      if ($read(%f,$lines(%f)) != $(#,0) $+ %h end) hfree %h
      else {
        hadd -m eircd3.plugins %h 1
        if (!$script(%f)) .load -rs $qt(%f)
        if (!$eircdv3(plugins,$gettok(%h,3,46)).set) {
          hadd -m eircd3.settings plugins. $+ %p 1
          writeini -n $qt($scriptdirsettings.ini) plugins %p 1
        }
      }
    }
    inc %a
  }
}

on *:DIALOG:eircd3.plugin.manager:*:*:{
  var %d $dname,%t $did(1).seltext,%h = eircd3.plugin. $+ $right($replace(%t,$chr(32),_),-2),%s $did(13).state
  if ($devent == INIT) {
    eircd3.load.plugins
    var %a 1
    while ($hget(eircd3.plugins,%a).item) {
      var %p $v1
      did -a %d 1 $iif($group($(#,0) $+ %p) == on,+,-) $replace($gettok(%p,3-,46),_,$chr(32))
      inc %a
    }
  }
  elseif ($devent == SCLICK) {
    if ($did == 1) {
      if (%h != eircd3.plugin.) {
        did -ra %d 12 Plugin Information: $right(%t,-2)
        did -ra %d 2 $hget(%h,author)
        did -ra %d 3 $hget(%h,version)
        did -ra %d 4 $hget(%h,website)
        did -ra %d 5 $hget(%h,contact)
        did -r %d 6
        var %a 1
        while ($hget(%h,desc. $+ %a)) {
          did -a %d 6 $iif(%a > 1,$crlf) $+ $hget(%h,desc. $+ %a)
          inc %a
        }
        did -c %d 6 1
        did -e $+ $iif(+* iswm %t,c,u) %d 13
      }
      else {
        did -ra %d 12 Plugin Information
        did -r %d 2,3,4,5,6
        did -ub %d 13
      }
    }
    elseif ($did == 13) {
      var %t $right($gettok($did(%d,12),2-,58),-1),%p = $replace(%t,$chr(32),_)
      did -o %d 1 $didwm($dname,1,? %t) $iif(%s,+,-) %t
      .signal $iif(!%s,-n) eircd3.plugin. $+ $iif(%s,on,off) %p
      $iif(%s,.enable,.disable) #eircd3.plugin. $+ %p
    }
  }
  elseif ($devent == DCLICK) && ($did == 1) {
    did -o %d 1 $did(1).sel $iif(%s,-,+) $right(%t,-2)
    did $iif(%s,-u,-c) %d 13
    .signal $iif(%s,-n) eircd3.plugin. $+ $iif(%s,off,on) $gettok(%h,3-,46)
    $iif(%s,.disable,.enable) $(#,0) $+ %h
  }
}

;#### ### ## #
;#
;#  EIRCD Setup Wizard
;#
;#### ### ## #

dialog eircd3.setup.wizard {
  title "EIRCD Setup Wizard"
  size -1 -1 400 353
  option pixels

  text "Help", 1, 10 20 381 219
  button "View Readme", 2, 316 281 75 25
  text "Note: This does not verify your settings, please use valid settings (explained in more detail in the readme).", 3, 10 279 305 27

  box "Welcome to the EIRCD Setup Wizard...", 4, 2 2 397 312
  text "EIRCD v3.0.-1", 8, 11 326 70 16, disable

  button "Cancel", 5, 322 322 75 25
  button "Next >>", 6, 236 322 75 25
  button "<< Back", 7, 158 322 75 25, disable

  text "This is the server address (something like irc.myserver.net). People can't connect to this address, its only used in server messages:", 21, 10 20 381 27, hide
  edit "irc.EIRCD.net", 22, 15 49 200 21, hide autohs
  text "This is the shortname for your server. It is used in various messages by the server and by mIRC as the Status Window's title:", 23, 10 75 381 29, hide
  edit "EIRCD", 24, 15 106 100 21, hide autohs
  text "This is a short description of your server (sent in a /whois):", 25, 10 132 381 16, hide
  edit "An EIRCD v3.0.-1 server", 26, 15 150 372 21, hide autohs
  text "This is the servers port that users connect to (6667 is the usuall server port):", 27, 10 174 381 16, hide
  edit "6667", 28, 15 192 50 21, hide autohs
  text "This is the location of the server (for example: Dallas, TX):", 29, 10 214 382 16, hide
  edit "Dallas, TX", 30, 15 232 100 21, hide autohs
  text "This is the password for your server. When set, only users that supply a correct password can connect to your server:", 31, 10 257 381 27, hide
  edit "", 32, 15 286 100 21, hide pass autohs

  text "This is the name of the server admin (either nickname or realname):", 41, 10 20 381 16, hide
  edit "Server Admin", 42, 15 38 150 21, hide autohs
  text "This is the email of the server admin:", 43, 10 63 381 16, hide
  edit "Server.Admin@email.com", 44, 15 81 250 21, hide autohs
  text "Note: This information is only sent with the /admin command on the server. If that command is disabled or removed this information is unused.", 45, 10 279 381 27, hide

  text "Hostmask", 61, 10 20 381 53, hide
  edit "EIRCD.user.", 62, 15 75 200 21, hide autohs
  text "This is the admin's IRCOp account:", 63, 10 99 381 16, hide
  edit "admin", 64, 15 117 100 21, hide autohs
  text "This is the password for the admin's IRCOp account (do NOT edit to keep an existing password). If this is your first time changing the settings you really should change this:", 65, 10 141 381 40, hide
  edit "********", 66, 15 183 100 21, hide pass autohs

  text "This is the Message of The Day. It is sent to users when they connect and can be viewed with the /motd command:", 81, 10 20 381 27, hide
  edit "", 82, 10 49 381 257, hide autohs autovs multi return

  text "This is the Oper Message of The Day. It is sent when IRCOps login and can be viewed by IRCOps with the /opermotd command:", 83, 10 20 381 27, hide
  edit "", 84, 10 49 381 257, hide autohs autovs multi return

  text "You have finished setting up EIRCD v3.0.-1! For more information on starting and using your server, view the readme.", 91, 10 20 381 27, hide
  check "View Readme", 92, 20 70 100 20, hide
  check "Manually Edit Settings", 93, 20 90 125 20, hide
  check "Start EIRCD", 94, 20 110 100 20, hide
}

alias eircd3.setup.wizard dialog $iif($dialog(eircd3.setup.wizard),-v,-md) eircd3.setup.wizard eircd3.setup.wizard

alias eircd3.sw return $hget(eircd3.setup.wizard,$1)

on *:DIALOG:eircd3.setup.wizard:*:*:{
  var %f $qt($scriptdirsettings.ini),%p $eircd3.sw(page),%h hadd -m eircd3.setup.wizard 
  if ($devent == init) {
    %h page 1
    %h dontask 1
    %h pass $regex($eircd3.readset(server,pass),^[a-z0-9]{32}$)
    %h operpass $ini(%f,ircops,0)
    did -ra $dname 1 $+(This wizard will take you step by step to change the basic settings of your EIRCD v3.0.-1 IRC server $chr(40),enough to start running it,$chr(41),. It is recommended that you read the readme before using the Setup Wizard. To change the more advanced settings that customize your server,$chr(44) you can open the settings.ini file with any file editor and edit the settings manually $chr(40),For advanced settings you MUST read the readme!,$chr(41),.,$crlf,$crlf,Click Next to continue or Cancel to exit the setup.)
    did -ra $dname 61 This is the hostmask of users when they set usermode +x. To keep users seperate a unique number is appended to the hostmask. For example a user could have the host "EIRCD.user.123" if the hostmask is set to "EIRCD.user." (You do not NEED to change this):
    did -c $dname 92,94
    var %a 1,%i 22 24 26 28 30 42 44 62,%s server,server server,name server,info server,port server,location admin,name admin,email settings,hostmask
    while ($gettok(%s,%a,32)) {
      did -ra $dname $gettok(%i,%a,32) $eircd3.readset( [ $v1 ] )
      inc %a
    }
    if ($eircd3.sw(pass)) did -ra $dname 32 *******
    if (!$eircd3.sw(operpass)) writeini -n %f ircops admin $md5(admin)
    did -ra $dname 64 $ini(%f,ircops,1)
    var %a 1,%f1 $qt($scriptdirmotd.txt),%f2 $qt($scriptdiropermotd.txt),%m = $lines(%f1),%o = $lines(%f2)
    while (%a <= %m) || (%a <= %o) {
      if (%a <= %m) did -a $dname 82 $read(%f1,%a)
      if (%a <= %o) did -a $dname 84 $read(%f2,%a)
      inc %a
    }
  }
  elseif ($devent == sclick) {
    if ($did == 2) run $qt($scriptdirreadme.html)
    elseif ($did == 5) dialog $iif($eircd3.sw(dontask) || $input(Are you sure you want to cancel the setup?,y,Cancel Setup Wizard?),-x,-v) $dname
    elseif ($did == 6) && (%p == 7) {
      var %a 1,%i 22 24 26 28 30 42 44 62,%s server server,server name,server info,server port,server location,admin name,admin email,settings hostmask
      while ($gettok(%i,%a,32)) {
        if ($did($v1)) writeini -n %f $gettok(%s,%a,44) $v1
        inc %a
      }
      if (!$did(32)) writeini -n %f server pass 0
      elseif (!$eircd3.sw(pass)) || ($did(32) != ********) writeini -n %f server pass $md5($v1)
      if ($did(66) != ********) write $+(-l,$calc(1+ $noop($read(%f,wn,[ircops])) $readn) %f $did(64),=,$iif($did(66),$md5($v1),$eircd3.readset(ircops,$ini(%f,ircops,1))))
      var %a 1,%f1 $qt($scriptdirmotd.txt),%f2 $qt($scriptdiropermotd.txt),%m $did(82).lines,%o $did(84).lines
      write -c %f1
      write -c %f2
      while (%a <= %m) || (%a <= %o) {
        if (%a <= %m) write $iif(%a == %m,-n) %f1 $did(82,%a)
        if (%a <= %o) write $iif(%a == %o,-n) %f2 $did(84,%a)
        inc %a
      }
      if ($did(92).state) run $qt($scriptdirreadme.html)
      if ($did(93).state) run %f
      if ($did(94).state) {
        if ($sock(eircd3)) eircd3.settings
        else eircd3
      }
      dialog -x eircd3.setup.wizard
    }
    elseif ($did isnum 6-7) {
      if ($eircd3.sw(dontask)) %h dontask 0
      var %i = 1,2,3 21,22,23,24,25,26,27,28,29,30,31,32 41,42,43,44,45 61,62,63,64,65,66 81,82 83,84 91,92,93,94,%t = Welcome to the EIRCD Setup Wizard...,Server Settings,Admin Settings,Hostmask and IRCop Settings,Message of The Day Settings,Oper Message of The Day Settings,Setup Complete!
      did -h $dname $gettok(%i,%p,32)
      $iif($did == 6,hinc,hdec) eircd3.setup.wizard page 1
      $iif($did == 6,inc,dec) %p
      did -ra $dname 4 $gettok(%t,%p,44)
      did -v $dname $gettok(%i,%p,32)
      if (%p == 2) && ($did == 6) did -e $dname 7
      elseif (%p == 7) {
        did -ra $dname 6 Done
        did -ra $dname 94 $iif($sock(eircd3),Reload Settings,Start EIRCD)
      }
      elseif ($did == 7) {
        if (%p == 1) did -b $dname 7
        elseif (%p == 6) did -ra $dname 6 Next >>
      }
    }
  }
  elseif ($devent == edit) {
    if ($eircd3.sw(dontask)) %h dontask 0
    var %a 1,%i 22,24,26,28,30 42,44 62,64,66
    while ($gettok($gettok(%i,$or($calc($did /20)),32),%a,44)) {
      if (!$did($v1)) {
        %a = 0
        did -b $dname 6,7
        break
      }
      inc %a
    }
    if (%a) {
      did -e $dname 6
      if (%p > 1) did -e $dname 7
    }
  }
}
