; HalfOps v1 by poiuy_qwert
; Website: None Contact: /server irc.gamesurge.net -j #EIRCD
; Requires EIRCD: v3.0.-1 Commands: * Modes: ohv/*
; Adds the channel mode Half-Op (%), which have the same capabilitites as Ops (@) except they can't add new Ops or Half-Ops.

#eircd3.plugin.HalfOps off
on *:SIGNAL:eircd3.*:{
  if ($signal == eircd3.setup) || ($signal $1 == eircd3.plugin.on HalfOps) {
    if (h !isincs $eircdv3(modes).set) {
      var %a 1,%bm,%bp,%sm,%sp
      while ($mid($eircdv3(prefixes).set,%a,1)) && ($mid($eircdv3(modes).set,%a,1)) {
        var %m $v1,%p = $mid($eircdv3(prefixes).set,%a,1)
        if (%m isincs $eircdv3(chanops).set) var %bm = %bm $+ %m,%bp = %bp $+ %p
        else var %sm = %sm $+ %m,%sp = %sp $+ %p
        inc %a
      }
      hadd -m eircd3.settings settings.modes $+(%bm,h,%sm)
      hadd eircd3.settings settings.prefixes $+(%bp,$(%,0),%sp)
      hadd eircd3.settings settings.chanops $eircdv3(chanops).set $+ h
    }
    hadd -m eircd3.modes cmode.o eircd3.plugin.HalfOps.cmode.o
    hadd eircd3.modes cmode.h eircd3.plugin.HalfOps.cmode.h
    hadd eircd3.modes cmode.v eircd3.plugin.HalfOps.cmode.v
  }
  elseif ($signal $1 == eircd3.plugin.off HalfOps) {
    hadd eircd3.settings settings.modes $removecs($eircdv3(modes).set,h)
    hadd eircd3.settings settings.prefixes $remove($eircdv3(prefixes).set,$(%,0))
    hadd eircd3.settings settings.chanops $removecs($eircdv3(chanops).set,h)
    hdel eircd3.modes cmode.o
    hdel eircd3.modes cmode.h
    hdel eircd3.modes cmode.v
  }
}

alias eircd3.plugin.HalfOps.cumode {
  var %h eircd3.chan. $+ $2,%n $hget($1,nick),%t $hget(eircd3.nicks,$4),%m = $hget(%h,%t)
  if ($isid) {
    if (($left($hget(%h,$1),1) == h) && ($5 isincs $eircdv3(chanops).set)) && (!$hget(eircd3.ircops,$1)) && ($3 == +) && ($1 != %t) return error 482 %n $2 :You must be a full channel operator.
    elseif (($left($hget(%h,$1),1) == h) || ($left($hget(%h,$1),1) !isincs $eircdv3(chanops).set)) && (!$hget(eircd3.ircops,$1)) && (($3 == +) || ($1 != %t)) return error 482 %n $2 :You must be a channel operator.
    elseif (!$4) || (($3 == +) && ($5 isincs %m)) || (($3 == -) && ($5 !isincs %m)) return $true
    elseif (!%t) return error 401 %n $4 :No such nick.
    elseif (!$hfind(%h,%t,0)) return error 441 %n $4 $2 :User not in channel.
  }
  elseif ($3 == +) {
    var %a 1,%p $eircdv3(modes).set
    while ($pos(%p,$mid(%m,%a,1),1) < $pos(%p,$5,1)) inc %a
    dec %a
    hadd %h %t $+($left(%m,%a),$5,$right(%m,$calc($len(%m)-%a)))
  }
  else hadd %h %t $removecs(%m,$5)
}
alias eircd3.plugin.HalfOps.cmode.o {
  if ($isid) && (!$prop) return $eircd3.plugin.HalfOps.cumode($1,$2,$3,$4,o)
  else eircd3.plugin.HalfOps.cumode $1-4 o
}
alias eircd3.plugin.HalfOps.cmode.h {
  if ($isid) && (!$prop) return $eircd3.plugin.HalfOps.cumode($1,$2,$3,$4,h)
  else eircd3.plugin.HalfOps.cumode $1-4 h
}
alias eircd3.plugin.HalfOps.cmode.v {
  if ($isid) && (!$prop) return $eircd3.plugin.HalfOps.cumode($1,$2,$3,$4,v)
  else eircd3.plugin.HalfOps.cumode $1-4 v
}
#eircd3.plugin.HalfOps end
